diff -r e32ff462bf6e trytond/modules/account_invoice/payment_term.py
--- a/trytond/modules/account_invoice/payment_term.py	Mon Sep 10 15:27:42 2012 +0200
+++ b/trytond/modules/account_invoice/payment_term.py	Mon Sep 24 20:36:39 2012 +0200
@@ -8,11 +8,12 @@
 from trytond.transaction import Transaction
 from trytond.pool import Pool
 
+__all__ = ['PaymentTerm', 'PaymentTermLine']
+
 
 class PaymentTerm(ModelSQL, ModelView):
     'Payment Term'
-    _name = 'account.invoice.payment_term'
-    _description = __doc__
+    __name__ = 'account.invoice.payment_term'
     name = fields.Char('Payment Term', size=None, required=True,
         translate=True)
     active = fields.Boolean('Active')
@@ -20,41 +21,39 @@
     lines = fields.One2Many('account.invoice.payment_term.line', 'payment',
             'Lines')
 
-    def __init__(self):
-        super(PaymentTerm, self).__init__()
-        self._order.insert(0, ('name', 'ASC'))
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(PaymentTerm, cls).__setup__()
+        cls._order.insert(0, ('name', 'ASC'))
+        cls._error_messages.update({
             'invalid_line': 'Invalid payment term line!',
             'missing_remainder': 'Payment term missing a remainder line!',
             })
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def compute(self, amount, currency, payment_term, date=None):
+    def compute(self, amount, currency, date=None):
         """Calculate payment terms and return a list of tuples
         with (date, amount) for each payment term line.
 
-        amount must be a Decimal used for the calculation and
-        both currency and payment_term must be BrowseRecord. If
-        specified, date will be used as the start date, otherwise
-        current date will be used.
+        amount must be a Decimal used for the calculation.
+        If specified, date will be used as the start date, otherwise current
+        date will be used.
         """
         #TODO implement business_days
         # http://pypi.python.org/pypi/BusinessHours/
-        pool = Pool()
-        line_obj = pool.get('account.invoice.payment_term.line')
-        currency_obj = pool.get('currency.currency')
-        date_obj = pool.get('ir.date')
+        Date = Pool().get('ir.date')
 
         sign = 1 if amount >= Decimal('0.0') else -1
         res = []
         if date is None:
-            date = date_obj.today()
+            date = Date.today()
         remainder = amount
-        for line in payment_term.lines:
-            value = line_obj.get_value(line, remainder, amount, currency)
-            value_date = line_obj.get_date(line, date)
+        for line in self.lines:
+            value = line.get_value(remainder, amount, currency)
+            value_date = line.get_date(date)
             if not value or not value_date:
                 if (not remainder) and line.amount:
                     self.raise_user_error('invalid_line')
@@ -66,17 +65,14 @@
             res.append((value_date, value))
             remainder -= value
 
-        if not currency_obj.is_zero(currency, remainder):
+        if not currency.is_zero(remainder):
             self.raise_user_error('missing_remainder')
         return res
 
-PaymentTerm()
-
 
 class PaymentTermLine(ModelSQL, ModelView):
     'Payment Term Line'
-    _name = 'account.invoice.payment_term.line'
-    _description = __doc__
+    __name__ = 'account.invoice.payment_term.line'
     sequence = fields.Integer('Sequence',
         order_field='(%(table)s.sequence IS NULL) %(order)s, '
         '%(table)s.sequence %(order)s',
@@ -111,7 +107,7 @@
             'required': Eval('type') == 'fixed',
             }, depends=['type'])
     currency_digits = fields.Function(fields.Integer('Currency Digits',
-        on_change_with=['currency']), 'get_currency_digits')
+        on_change_with=['currency']), 'on_change_with_currency_digits')
     day = fields.Integer('Day of Month')
     month = fields.Selection([
             (None, ''),
@@ -142,132 +138,126 @@
     weeks = fields.Integer('Number of Weeks', required=True)
     days = fields.Integer('Number of Days', required=True)
 
-    def __init__(self):
-        super(PaymentTermLine, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
-        self._sql_constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(PaymentTermLine, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
+        cls._sql_constraints += [
             ('day', 'CHECK(day BETWEEN 1 AND 31)',
                 'Day of month must be between 1 and 31.'),
             ]
-        self._constraints += [
+        cls._constraints += [
             ('check_percentage_and_divisor', 'invalid_percentage_and_divisor'),
             ]
-        self._error_messages.update({
+        cls._error_messages.update({
                 'invalid_percentage_and_divisor': 'Percentage and '
                         'Divisor values are not consistent.',
                 })
 
-    def init(self, module_name):
-        super(PaymentTermLine, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(PaymentTermLine, cls).__register__(module_name)
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
         # Migration from 1.0 percent change into percentage
         if table.column_exist('percent'):
-            cursor.execute('UPDATE "' + self._table + '" ' \
+            cursor.execute('UPDATE "' + cls._table + '" ' \
                     'SET percentage = percent * 100')
             table.drop_column('percent', exception=True)
 
         # Migration from 2.2
         if table.column_exist('delay'):
-            cursor.execute('UPDATE "' + self._table + '" SET day = 31 '
+            cursor.execute('UPDATE "' + cls._table + '" SET day = 31 '
                 "WHERE delay = 'end_month'")
             table.drop_column('delay', exception=True)
-            ids = self.search([])
-            for line in self.browse(ids):
+            lines = cls.search([])
+            for line in lines:
                 if line.percentage:
-                    self.write(line.id, {
-                            'divisor': self.round(Decimal('100.0') /
-                                line.percentage, self.divisor.digits[1]),
+                    cls.write([line], {
+                            'divisor': cls.round(Decimal('100.0') /
+                                line.percentage, cls.divisor.digits[1]),
                             })
 
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-    def default_currency_digits(self):
+    @staticmethod
+    def default_currency_digits():
         return 2
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return 'remainder'
 
-    def default_months(self):
+    @staticmethod
+    def default_months():
         return 0
 
-    def default_weeks(self):
+    @staticmethod
+    def default_weeks():
         return 0
 
-    def default_days(self):
+    @staticmethod
+    def default_days():
         return 0
 
-    def on_change_type(self, vals):
-        if not 'type' in vals:
-            return {}
+    def on_change_type(self):
         res = {}
-        if vals['type'] != 'fixed':
+        if self.type != 'fixed':
             res['amount'] = Decimal('0.0')
             res['currency'] = None
-        if vals['type'] not in ('percent', 'percent_on_total'):
+        if self.type not in ('percent', 'percent_on_total'):
             res['percentage'] = Decimal('0.0')
             res['divisor'] = Decimal('0.0')
         return res
 
-    def on_change_percentage(self, value):
-        if not value.get('percentage'):
+    def on_change_percentage(self):
+        if not self.percentage:
             return {'divisor': 0.0}
         return {
-            'divisor': self.round(Decimal('100.0') / value['percentage'],
-                self.divisor.digits[1]),
+            'divisor': self.round(Decimal('100.0') / self.percentage,
+                self.__class__.divisor.digits[1]),
             }
 
-    def on_change_divisor(self, value):
-        if not value.get('divisor'):
+    def on_change_divisor(self):
+        if not self.divisor:
             return {'percentage': 0.0}
         return {
-            'percentage': self.round(Decimal('100.0') / value['divisor'],
-                self.percentage.digits[1]),
+            'percentage': self.round(Decimal('100.0') / self.divisor,
+                self.__class__.percentage.digits[1]),
             }
 
-    def on_change_with_currency_digits(self, vals):
-        currency_obj = Pool().get('currency.currency')
-        if vals.get('currency'):
-            currency = currency_obj.browse(vals['currency'])
-            return currency.digits
+    def on_change_with_currency_digits(self, name=None):
+        if self.currency:
+            return self.currency.digits
         return 2
 
-    def get_currency_digits(self, ids, name):
-        res = {}
-        for line in self.browse(ids):
-            if line.currency:
-                res[line.id] = line.currency.digits
-            else:
-                res[line.id] = 2
-        return res
-
-    def get_delta(self, line):
+    def get_delta(self):
         return {
-            'day': line.day,
-            'month': int(line.month) if line.month else None,
-            'days': line.days,
-            'weeks': line.weeks,
-            'months': line.months,
-            'weekday': int(line.weekday) if line.weekday else None,
+            'day': self.day,
+            'month': int(self.month) if self.month else None,
+            'days': self.days,
+            'weeks': self.weeks,
+            'months': self.months,
+            'weekday': int(self.weekday) if self.weekday else None,
             }
 
-    def get_date(self, line, date):
-        return date + relativedelta(**self.get_delta(line))
+    def get_date(self, date):
+        return date + relativedelta(**self.get_delta())
 
-    def get_value(self, line, remainder, amount, currency):
-        currency_obj = Pool().get('currency.currency')
-        if line.type == 'fixed':
-            return currency_obj.compute(line.currency, line.amount, currency)
-        elif line.type == 'percent':
-            return currency_obj.round(currency,
-                remainder * line.percentage / Decimal('100'))
-        elif line.type == 'percent_on_total':
-            return currency_obj.round(currency,
-                amount * line.percentage / Decimal('100'))
-        elif line.type == 'remainder':
-            return currency_obj.round(currency, remainder)
+    def get_value(self, remainder, amount, currency):
+        Currency = Pool().get('currency.currency')
+        if self.type == 'fixed':
+            return Currency.compute(self.currency, self.amount, currency)
+        elif self.type == 'percent':
+            return currency.round(
+                remainder * self.percentage / Decimal('100'))
+        elif self.type == 'percent_on_total':
+            return currency.round(
+                amount * self.percentage / Decimal('100'))
+        elif self.type == 'remainder':
+            return currency.round(remainder)
         return None
 
     @staticmethod
@@ -275,11 +265,12 @@
         quantize = Decimal(10) ** -Decimal(digits)
         return Decimal(number).quantize(quantize)
 
-    def check_percentage_and_divisor(self, ids):
+    @classmethod
+    def check_percentage_and_divisor(cls, lines):
         "Check consistency between percentage and divisor"
-        percentage_digits = self.percentage.digits[1]
-        divisor_digits = self.divisor.digits[1]
-        for line in self.browse(ids):
+        percentage_digits = cls.percentage.digits[1]
+        divisor_digits = cls.divisor.digits[1]
+        for line in lines:
             if line.type not in ('percent', 'percent_on_total'):
                 continue
             if line.percentage is None or line.divisor is None:
@@ -288,14 +279,12 @@
                 continue
             percentage = line.percentage
             divisor = line.divisor
-            calc_percentage = self.round(Decimal('100.0') / divisor,
+            calc_percentage = cls.round(Decimal('100.0') / divisor,
                     percentage_digits)
-            calc_divisor = self.round(Decimal('100.0') / percentage,
+            calc_divisor = cls.round(Decimal('100.0') / percentage,
                     divisor_digits)
             if (percentage == Decimal('0.0') or divisor == Decimal('0.0')
                     or percentage != calc_percentage
                     and divisor != calc_divisor):
                 return False
         return True
-
-PaymentTermLine()
diff -r e32ff462bf6e trytond/modules/account_invoice/tests/test_account_invoice.py
--- a/trytond/modules/account_invoice/tests/test_account_invoice.py	Mon Sep 10 15:27:42 2012 +0200
+++ b/trytond/modules/account_invoice/tests/test_account_invoice.py	Mon Sep 24 20:36:39 2012 +0200
@@ -45,14 +45,13 @@
         Test payment_term.
         '''
         with Transaction().start(DB_NAME, USER, context=CONTEXT):
-            cu1_id = self.currency.create({
+            cu1 = self.currency.create({
                     'name': 'cu1',
                     'symbol': 'cu1',
                     'code': 'cu1'
                     })
-            cu1 = self.currency.browse(cu1_id)
 
-            term_id = self.payment_term.create({
+            term = self.payment_term.create({
                     'name': '30 days, 1 month, 1 month + 15 days',
                     'lines': [
                         ('create', {
@@ -75,7 +74,7 @@
                                 'months': 1,
                                 'days': 30,
                                 'amount': Decimal('396.84'),
-                                'currency': cu1_id,
+                                'currency': cu1.id,
                                 }),
                         ('create', {
                                 'sequence': 3,
@@ -85,9 +84,8 @@
                                 'day': 15,
                                 })]
                     })
-            term = self.payment_term.browse(term_id)
-            terms = term.compute(Decimal('1587.35'), cu1, term,
-                    date=datetime.date(2011, 10, 1))
+            terms = term.compute(Decimal('1587.35'), cu1,
+                date=datetime.date(2011, 10, 1))
             self.assertEqual(terms, [
                     (datetime.date(2011, 10, 31), Decimal('396.84')),
                     (datetime.date(2011, 11, 01), Decimal('396.84')),
diff -r ccb27f24a097 trytond/modules/account_invoice_history/__init__.py
--- a/trytond/modules/account_invoice_history/__init__.py	Tue Sep 04 23:04:16 2012 +0200
+++ b/trytond/modules/account_invoice_history/__init__.py	Mon Sep 24 20:36:39 2012 +0200
@@ -1,6 +1,17 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .party import *
 from .payment_term import *
 from .invoice import *
+
+
+def register():
+    Pool.register(
+        Party,
+        Address,
+        PaymentTerm,
+        PaymentTermLine,
+        Invoice,
+        module='account_invoice_history', type_='model')
diff -r ccb27f24a097 trytond/modules/account_invoice_history/invoice.py
--- a/trytond/modules/account_invoice_history/invoice.py	Tue Sep 04 23:04:16 2012 +0200
+++ b/trytond/modules/account_invoice_history/invoice.py	Mon Sep 24 20:36:39 2012 +0200
@@ -1,49 +1,43 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 import datetime
-import copy
-from trytond.model import Model, fields
 
+from trytond.model import fields
+from trytond.pool import PoolMeta
 
-class Invoice(Model):
-    _name = 'account.invoice'
+__all__ = ['Invoice']
+__metaclass__ = PoolMeta
+
+
+class Invoice:
+    __name__ = 'account.invoice'
     open_date = fields.DateTime('Open Date')
 
-    def __init__(self):
-        super(Invoice, self).__init__()
-        self.party = copy.copy(self.party)
-        self.party.datetime_field = 'open_date'
-        if 'open_date' not in self.party.depends:
-            self.party.depends = copy.copy(self.party.depends)
-            self.party.depends.append('open_date')
-        self.invoice_address = copy.copy(self.invoice_address)
-        self.invoice_address.datetime_field = 'open_date'
-        if 'open_date' not in self.invoice_address.depends:
-            self.invoice_address.depends = copy.copy(
-                    self.invoice_address.depends)
-            self.invoice_address.depends.append('open_date')
-        self.payment_term = copy.copy(self.payment_term)
-        self.payment_term.datetime_field = 'open_date'
-        if 'open_date' not in self.payment_term.depends:
-            self.payment_term.depends = copy.copy(
-                    self.payment_term.depends)
-            self.payment_term.depends.append('open_date')
-        self._reset_columns()
+    @classmethod
+    def __setup__(cls):
+        super(Invoice, cls).__setup__()
+        cls.party.datetime_field = 'open_date'
+        if 'open_date' not in cls.party.depends:
+            cls.party.depends.append('open_date')
+        cls.invoice_address.datetime_field = 'open_date'
+        if 'open_date' not in cls.invoice_address.depends:
+            cls.invoice_address.depends.append('open_date')
+        cls.payment_term.datetime_field = 'open_date'
+        if 'open_date' not in cls.payment_term.depends:
+            cls.payment_term.depends.append('open_date')
 
-    def set_number(self, invoice):
-        set_open_date = not invoice.number
-        res = super(Invoice, self).set_number(invoice)
+    def set_number(self):
+        set_open_date = not self.number
+        super(Invoice, self).set_number()
         if set_open_date:
-            self.write(invoice.id, {
-                'open_date': datetime.datetime.now(),
-                })
-        return res
+            self.write([self], {
+                    'open_date': datetime.datetime.now(),
+                    })
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, invoices, default=None):
         if default is None:
             default = {}
         default = default.copy()
         default['open_date'] = None
-        return super(Invoice, self).copy(ids, default=default)
-
-Invoice()
+        return super(Invoice, cls).copy(invoices, default=default)
diff -r ccb27f24a097 trytond/modules/account_invoice_history/party.py
--- a/trytond/modules/account_invoice_history/party.py	Tue Sep 04 23:04:16 2012 +0200
+++ b/trytond/modules/account_invoice_history/party.py	Mon Sep 24 20:36:39 2012 +0200
@@ -1,17 +1,16 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from trytond.model import ModelView, ModelSQL
+from trytond.pool import PoolMeta
 
+__all__ = ['Party', 'Address']
+__metaclass__ = PoolMeta
 
-class Party(ModelSQL, ModelView):
-    _name = 'party.party'
+
+class Party:
+    __name__ = 'party.party'
     _history = True
 
-Party()
 
-
-class Address(ModelSQL, ModelView):
-    _name = 'party.address'
+class Address:
+    __name__ = 'party.address'
     _history = True
-
-Address()
diff -r ccb27f24a097 trytond/modules/account_invoice_history/payment_term.py
--- a/trytond/modules/account_invoice_history/payment_term.py	Tue Sep 04 23:04:16 2012 +0200
+++ b/trytond/modules/account_invoice_history/payment_term.py	Mon Sep 24 20:36:39 2012 +0200
@@ -1,17 +1,16 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from trytond.model import ModelView, ModelSQL
+from trytond.pool import PoolMeta
 
+__all__ = ['PaymentTerm', 'PaymentTermLine']
+__metaclass__ = PoolMeta
 
-class PaymentTerm(ModelSQL, ModelView):
-    _name = 'account.invoice.payment_term'
+
+class PaymentTerm:
+    __name__ = 'account.invoice.payment_term'
     _history = True
 
-PaymentTerm()
 
-
-class PaymentTermLine(ModelSQL, ModelView):
-    _name = 'account.invoice.payment_term.line'
+class PaymentTermLine:
+    __name__ = 'account.invoice.payment_term.line'
     _history = True
-
-PaymentTermLine()
diff -r b3d1f8ddf175 trytond/modules/account_invoice_line_standalone/__init__.py
--- a/trytond/modules/account_invoice_line_standalone/__init__.py	Fri Jun 08 19:33:37 2012 +0200
+++ b/trytond/modules/account_invoice_line_standalone/__init__.py	Mon Sep 24 20:36:39 2012 +0200
@@ -1,4 +1,12 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .invoice import *
+
+
+def register():
+    Pool.register(
+        Invoice,
+        InvoiceLine,
+        module='account_invoice_line_standalone', type_='model')
diff -r b3d1f8ddf175 trytond/modules/account_invoice_line_standalone/invoice.py
--- a/trytond/modules/account_invoice_line_standalone/invoice.py	Fri Jun 08 19:33:37 2012 +0200
+++ b/trytond/modules/account_invoice_line_standalone/invoice.py	Mon Sep 24 20:36:39 2012 +0200
@@ -1,17 +1,19 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-import copy
-from trytond.model import ModelView, ModelSQL
 from trytond.pyson import Eval
 from trytond.transaction import Transaction
+from trytond.pool import PoolMeta
 
+__all__ = ['Invoice', 'InvoiceLine']
+__metaclass__ = PoolMeta
 
-class Invoice(ModelSQL, ModelView):
-    _name = 'account.invoice'
 
-    def __init__(self):
-        super(Invoice, self).__init__()
-        self.lines = copy.copy(self.lines)
+class Invoice:
+    __name__ = 'account.invoice'
+
+    @classmethod
+    def __setup__(cls):
+        super(Invoice, cls).__setup__()
         add_remove = [
             ('invoice_type', '=', Eval('type')),
             ('party', '=', Eval('party')),
@@ -20,28 +22,23 @@
             ('invoice', '=', None),
         ]
 
-        if not self.lines.add_remove:
-            self.lines.add_remove = add_remove
+        if not cls.lines.add_remove:
+            cls.lines.add_remove = add_remove
         else:
-            self.lines.add_remove = copy.copy(self.lines.add_remove)
-            self.lines.add_remove = [
+            cls.lines.add_remove = [
                 add_remove,
-                self.lines.add_remove,
-            ]
-        self._reset_columns()
+                cls.lines.add_remove,
+                ]
 
-Invoice()
 
+class InvoiceLine:
+    __name__ = 'account.invoice.line'
 
-class InvoiceLine(ModelSQL, ModelView):
-    _name = 'account.invoice.line'
-
-    def _view_look_dom_arch(self, tree, type, field_children=None):
+    @classmethod
+    def _view_look_dom_arch(cls, tree, type, field_children=None):
         if type == 'form' and Transaction().context.get('standalone'):
             tree_root = tree.getroottree().getroot()
             if tree_root.get('cursor') == 'product':
                 tree_root.set('cursor', 'party')
-        return super(InvoiceLine, self)._view_look_dom_arch(tree, type,
+        return super(InvoiceLine, cls)._view_look_dom_arch(tree, type,
             field_children=field_children)
-
-InvoiceLine()
diff -r 5810df9693e2 trytond/modules/account_product/__init__.py
--- a/trytond/modules/account_product/__init__.py	Fri Jun 08 19:33:38 2012 +0200
+++ b/trytond/modules/account_product/__init__.py	Mon Sep 24 20:36:39 2012 +0200
@@ -1,4 +1,16 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .product import *
+
+
+def register():
+    Pool.register(
+        Category,
+        CategoryCustomerTax,
+        CategorySupplierTax,
+        Template,
+        TemplateCustomerTax,
+        TemplateSupplierTax,
+        module='account_product', type_='model')
